
R8ToStr proto :real8,:PTR
include Int3264ToStr.asm
include Convert.inc

R8_BIAS equ 1023
R8_MANT equ 52

.xmm
.code

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

	align 16
R8ToStr proc r8:REAL8, lpBuffer:PTR

	tmpbuffsize equ 32
	saveregssize equ 4*4 
	locals equ tmpbuffsize + saveregssize + 4+4+4
	tmpbuff equ <[esp]>
	saveregs equ <[esp+tmpbuffsize]>
	dwSign equ <[esp+tmpbuffsize+saveregssize+0*4]>
	dwExp equ <[esp+tmpbuffsize+saveregssize+1*4]>
	dwTmp equ <[esp+tmpbuffsize+saveregssize+2*4]>
	pValue equ <[esp+locals+1*4]>
	pBuffer equ <[esp+locals+3*4]>

	sub esp,locals
	mov saveregs[0*4],ebp
	mov saveregs[1*4],esi
	mov saveregs[2*4],edi
	mov saveregs[3*4],ebx
	mov eax,pValue[4]
	mov esi,pValue[0]
	cdq
	and eax,01111111111111111111111111111111b; clear sign
	mov dwSign,edx
	mov edi,eax
	and edi,00000000000011111111111111111111b; high bits of mantissa
	shr eax,52-32
	cmp eax,11111111111b
	je @@NaNOrInfinity
	test eax,eax
	jz @@SubnormalOrZero
	or  edi,00000000000100000000000000000000b; + 1 implied
;	sub ebx,R8_BIAS;
;	sub ebx,R8_MANT ; move the "dot" from "11:zero:bits<implied:bit>.52bit:mant" to "<64:bit:uint>."
;	sub ebx,64-(R8_MANT+1); substract Log2(2^11)

	sub eax,R8_BIAS+R8_MANT+(64-(R8_MANT+1));
	mov ecx,(1 shl 6)-1 ;; (2^n) - 1
	mov ebx,eax
	shld edi,esi,64-(R8_MANT+1)
	shl esi,64-(R8_MANT+1)
	; divide by 64 (result should be in range -16..15), remainder in ecx
@@SubnormalReturn:	
	cdq 
	and edx,ecx 
	add eax,edx
	and ecx,eax
	sar eax,6
	sub ecx,edx
	;dbg T("{Unpack.} %I64u *2^%i, div64=%i, mod64=%i",13,10),edi::esi,ebx,eax,ecx
	mov edx,eax
	xor ebp,ebp; decexp
	sal edx,6;imul edx,eax,64
	sub ebx,edx; binexp -= ((expdiv64) * 64)
	sub ebp,tab_2x10x_div_exp[eax*4+16*4]
	mov dwTmp,ecx; ecx=(int)(binexp%64)
	mov dwExp,ebp; decexp
	mov ebp,eax; eax=(int)(binexp/64)

	;dbg T("Mulc = %I64u",13,10),tab_2x10x_div[eax*8+16*8]
	;; edi::esi *= tab_2x10x_div[eax*8+16*8]
	_mul_64x64_top64 tab_2x10x_div[ebp*8+16*8][0],tab_2x10x_div[ebp*8+16*8][4]
	;dbg T("{after mul.} %I64u *2^%i *10^%i",13,10),edi::esi,ebx,ebp
	mov ebp,dwTmp
	test ebp,ebp
	.if !zero?
		movsx edx,tab_2x10x_mod_exp[ebp+64]
		add dwExp,edx
		;dbg T("Mulc = %I64u",13,10),tab_2x10x_mod[ebp*8+64*8]
		;; edi::esi *= tab_2x10x_mod[ecx*8+64*8]
		_mul_64x64_top64 tab_2x10x_mod[ebp*8+64*8][0],tab_2x10x_mod[ebp*8+64*8][4]
		;dbg T("{after mul.} %I64u *2^%i *10^%i",13,10),edi::esi,ebx,0
	.endif
	; 40 cycles for converting from n*2^m to x*10^y

	ReduceAndRoundTo15Digits

	InternalR8Format3
	
@@Done:
	mov eax,edi	
	mov ebp,saveregs[0*4]
	mov esi,saveregs[1*4]
	mov edi,saveregs[2*4]
	mov ebx,saveregs[3*4]
	add esp,locals
	sub eax,[esp+3*4]
	ret REAL8 + DWORD
	
@@NaNOrInfinity:
	mov ebx,edi
	mov eax,edi
	mov ecx,dwSign
	mov edi,pBuffer
	xor edx,edx
	mov dl,cl
	and dl,'-'
	mov [edi],dl
	sub edi,ecx
	or eax,esi
	mov dword ptr [edi],'#.1'	
	.if zero?
		mov eax,'FNI'
		mov [edi+3],eax	
		add edi,6
		jmp @@Done
	.endif
	.if ebx > 7FFFFH
		mov eax,'NANQ'
		mov [edi+3],eax	
		mov byte ptr [edi+7],0
		add edi,7
		jmp @@Done
	.endif

;	test esi,esi
;	.if sign?
		mov eax,'NANS'
		mov [edi+3],eax	
		mov byte ptr [edi+7],0
		add edi,7
		jmp @@Done
;	.endif
;	mov eax,'DNI'
;	mov [edi+3],eax	
;	add edi,6
;	jmp @@Done

@@Zero:
	mov ecx,dwSign
	mov edi,pBuffer
	xor edx,edx
	mov dl,cl
	and dl,'-'
	mov [edi],dl
	sub edi,ecx
	mov word ptr [edi],'0'	
	add edi,1
	jmp @@Done

@@SubnormalOrZero:
	mov edx,esi
	or edx,edi
	or edx,eax
	jz @@Zero

	mov eax,-1022-R8_MANT

	.if !edi
		mov edi,esi
		xor esi,esi
		sub eax,32
	.endif
	
	mov ecx,31
	bsr edx,edi
	sub ecx,edx
	sub eax,ecx
	shld edi,esi,cl
	shl esi,cl
	
	mov ebx,eax
	mov ecx,(1 shl 6)-1 ;; (2^n) - 1

	jmp @@SubnormalReturn

R8ToStr endp 
%echo R8ToStr: @CatStr(%($-R8ToStr)) bytes

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

